package net.yale.cs.p4p.p2p.azureus.client.data;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import net.yale.cs.p4p.p2p.azureus.client.P4PPlugin;

import org.gudy.azureus2.plugins.torrent.Torrent;

public class Torrents
{

	private P4PPlugin plugin_;
	private Map<String, TorrentState> torrents_ = new HashMap<String, TorrentState>();

	public Torrents(P4PPlugin plugin) {
		plugin_ = plugin;
	}

	private static final String getTorrentKey(Torrent torrent) {
		return new String(torrent.getHash());
	}

	public synchronized Collection<TorrentState> getAll() {
		return new ArrayList<TorrentState>(torrents_.values());
	}

	public synchronized TorrentState getTorrent(Torrent torrent) {
		String torrentKey = getTorrentKey(torrent);
		TorrentState result = torrents_.get(torrentKey);
		if (result == null)
			torrents_.put(torrentKey, result = new TorrentState(plugin_, torrent));
		return result;
	}

	public synchronized TorrentState getTorrentByName(String name) {
		for (Map.Entry<String, TorrentState> e : torrents_.entrySet())
			if (name.equals(e.getValue().getTorrent().getName()))
				return e.getValue();
		return null;
	}

	public synchronized void removeTorrent(Torrent torrent) {
		torrents_.remove(getTorrentKey(torrent));
	}

}
